package com.example.mylog;


import java.text.SimpleDateFormat;
import java.util.Date;
import org.apache.http.impl.cookie.DateParseException;
import org.apache.http.impl.cookie.DateUtils;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.os.IBinder;
import android.provider.CallLog;
import android.telephony.PhoneStateListener;
import android.telephony.TelephonyManager;
import android.util.Log;



public class PhoneService extends Service {
	
	private static final String TAG = PhoneService.class.getSimpleName();
	public DBAdapter db;

	// Create Telephony + Listener variables
    public TelephonyManager telephony;
	public MyPhoneStateListener phoneListener;

	
	// Specify formatting of data and time --> looks awesome :D
	SimpleDateFormat formatDate = new SimpleDateFormat("dd-MM-yyyy");
	SimpleDateFormat formatTime = new SimpleDateFormat("HH:mm:ss");
	
	
	// Specify formatting for duration --> looks even more awesome :D	
	public String formatDuration(String input) {
		
		long seconds = Long.parseLong(input);
	    StringBuffer buf = new StringBuffer();
	    Log.d(TAG, input);

	    int h = (int) Math.floor(seconds / 3600);
	    int m = (int) Math.floor((seconds - h * 3600) / 60);
	    int s = (int) seconds - h - m;

	    buf
	        .append(String.format("%02d", h))
	        .append(":")
	        .append(String.format("%02d", m))
	        .append(":")
	        .append(String.format("%02d", s));

	    return buf.toString();
	}	
	
	
	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}
	
	@Override
	public void onCreate() {
		super.onCreate();
			
  		// Create Database
		db = new DBAdapter(getApplicationContext());
		
		// Collect call history + write into database (happens right after installation)
		
		Log.d(TAG, "Log Collection is about to begin");
		/*
		Cursor c = getContentResolver().query(
						android.provider.CallLog.Calls.CONTENT_URI,
						null, null, null,
						android.provider.CallLog.Calls.DATE + " DESC");
						
						
		/* Retrieve the column-indices of required details */
/*
 		int nameColumn = c.getColumnIndex(android.provider.CallLog.Calls.CACHED_NAME);
		int numberColumn = c.getColumnIndex(android.provider.CallLog.Calls.NUMBER);
		int durationColumn = c.getColumnIndex(android.provider.CallLog.Calls.DURATION);
		int dateColumn = c.getColumnIndex(android.provider.CallLog.Calls.DATE);
		int typeColumn = c.getColumnIndex(android.provider.CallLog.Calls.TYPE);				
						
		/* Iterate through the whole history and save data on database */
		/*
		db.open();*/

		/*while(!c.isAfterLast())
		 		{
		 						String k = c.getString(dateColumn);
								name = c.getString(nameColumn);		 					
								phonenumber = c.getString(numberColumn);
								String d = c.getString(durationColumn);
								int callType = c.getInt(typeColumn);
		 		                switch(callType)	{
		                        	case android.provider.CallLog.Calls.INCOMING_TYPE:
										callclassification = "Incoming Call";
										break;
									case android.provider.CallLog.Calls.OUTGOING_TYPE:
										callclassification = "Outgoing Call";
										break;
								}
		 
		                      // Format date/time/duration
		 		              Date temp = null;
		 		              try {
		 		            	  temp = DateUtils.parseDate(k);
		 		              } catch (DateParseException e) {
								// Nothing
								e.printStackTrace();
		 		              }
		 		              
 							  date = formatDate.format(temp);
 							  time = formatTime.format(temp);
 							  duration = formatDuration(d);
 								  
							  // Write into database
			  				  db.insertCallLogs(date, time, name, phonenumber, duration, callclassification);
			  				  
			  				  // Move on to next entry
			  				  c.moveToNext();

		           } */
		
		/*  db.close();

		Log.d(TAG, "Log Collection has ended");*/

		  
		// Put a Listener on the Phone-State for registering further changes
		telephony = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);
		phoneListener = new MyPhoneStateListener();
	    telephony.listen(phoneListener,PhoneStateListener.LISTEN_CALL_STATE);
		
	}
	     

	
	//////// Private Class MyPhoneStateListener /////////
	
	private class MyPhoneStateListener extends PhoneStateListener {
		

    	// This method is a Listener on the Phone State: Whenever it changes --> a new query is made to Call Logs
  		
		public void onCallStateChanged(int state, String incomingNumber){
			  
		 	  Log.d(TAG, "STATE HAS CHANGED!");
		 	  
			  // Register New Phone Logs  
			  
			  switch(state){
			  	case TelephonyManager.CALL_STATE_IDLE:
			  		Log.d(TAG, "Phone is in idle state.");
			  		CollectAndSaveLogs();
			  		break;
			  	case TelephonyManager.CALL_STATE_OFFHOOK:
			  		Log.d(TAG, "Phone-User has initiated/accepted a call");
			  		break;
			  	case TelephonyManager.CALL_STATE_RINGING:
		    		Log.d(TAG, "Phone-User has received a call");
		    		break;
			  }
			  
			  

			  
		  }

	}
	
	
	
		public void CollectAndSaveLogs()	{
			
			// Declare all values, which need to be logged
			
			String date;
			String time;    	
			String name;
			String phonenumber;
			String duration;
			String callclassification;
			String d;	
			
			
			
		  // Collect new Phone Logs //
		  
	      Cursor c = getContentResolver().query(
		               android.provider.CallLog.Calls.CONTENT_URI,
		               null,
		               null,
		               null,
		               android.provider.CallLog.Calls.DATE + " ASC");
	 	   
	      c.moveToFirst();
	      
		   date = formatDate.format(new Date());
		   time = formatTime.format(new Date());
	 	   name = c.getString(c.getColumnIndex(CallLog.Calls.CACHED_NAME));
	 	   phonenumber = c.getString(c.getColumnIndex(CallLog.Calls.NUMBER));
	 	   d = c.getString(c.getColumnIndex(CallLog.Calls.DURATION));
	 	   duration = formatDuration(d);
	 	   callclassification = c.getString(c.getColumnIndex(CallLog.Calls.TYPE));
	  
	  		Log.d(TAG, date);
	  		Log.d(TAG, time);
	  		Log.d(TAG, name);
	  		Log.d(TAG, phonenumber);
	  		Log.d(TAG, duration);
	  		Log.d(TAG, callclassification);
	  		
	  		c.close();
	  		
		  // Write new Phone Logs in Database //
		  
		  db.open();
		  db.insertCallLogs(date, time, name, phonenumber, duration, callclassification);
		  db.close();
		
		}
	
	
}